<?php
/**
 * Here you build the include/amazon-ws/assets/nodes-{country}.csv files based on data inf file browsenodes.csv
 * HOW TO MAKE A REQUEST:
 * /wp-content/plugins/woozone-contextual/_utils/browsenodes2nodes.php?write=true&country=all
 */
 
if ( !defined('ABSPATH') ) {
	$absolute_path = __FILE__;
	$path_to_file = explode( 'wp-content', $absolute_path );
	$path_to_wp = $path_to_file[0];

	/** Set up WordPress environment */
	require_once( $path_to_wp.'/wp-load.php' );
} else {
	die('wrong path!');
}

//'CA','CN','DE','ES','FR','IN','IT','JP','UK','US','BR','MX'
$__allowedCountries = array(
	'CA' 	=> 'ca',
	'CN' 	=> 'cn',
	'DE' 	=> 'de',
	'ES' 	=> 'es',
	'FR' 	=> 'fr',
	'IN' 	=> 'in',
	'IT' 	=> 'it',
	'JP' 	=> 'jp',
	'UK' 	=> 'uk',
	'US' 	=> 'com',
	'BR' 	=> 'br',
	'MX' 	=> 'mx'
);

function generateAssetsFiles( $write=true, $country='all' ) {
	assets_browsenodes( $write, $country );
}

function assets_browsenodes( $write=true, $country='all' ) {
	global $WooZone_Contextual, $__allowedCountries;

	$file_name = 'browsenodes.csv';

	/*$content = $WooZone_Contextual->wp_filesystem->get_contents(
		$file_name
	);
	if( !$content ){
		$content = file_get_contents( $file_name );
	}*/
	$content = my_fgetcsv( $file_name );
	
	if ( empty($content) || ! is_array($content) ) {
		$read_status = false;
		echo '<div style="display: block;">' . $file_name .  '<span style="display: inline-block; margin-left: 20px; color: #' . ($read_status ? '00ff00' : 'ff0000') . '">' . ($read_status ? 'success' : 'error') . ' - reading file content</span></div>';
		return false;
	}
	//var_dump('<pre>', $content, '</pre>'); echo __FILE__ . ":" . __LINE__;die . PHP_EOL;

	//$csv = array_map('str_getcsv', $content);
	//$csv = csv_to_array( $content, "\n" );
	$csv = $content;
	//var_dump('<pre>', $csv, '</pre>'); echo __FILE__ . ":" . __LINE__;die . PHP_EOL;

	//:: build the assets
	$ret = array();
	$countries = array();

	foreach ( $csv[0] as $key => $val ) {
		if ( empty($val) ) continue 1;

		$ret["$val"] = array();
		$countries["$key"] = $val;
	}
	unset( $csv[0] );

	//if ( empty($csv) ) return;
	$ii_rows = 0;	
	foreach ($csv as $key => $nodes) {
		$ii_rows++;
		if ( empty($nodes) ) continue 1;

		$ii_cols = 0; $categ_name = '';
		foreach ($nodes as $key2 => $val2) {
			$ii_cols++;
			if ( ! $key2 ) {
				$categ_name = $val2;
			}
			if ( empty($val2) ) continue 1;

			$_country = isset($countries["$key2"]) ? $countries["$key2"] : '';
			if ( '' == $_country ) {
				continue 1;
			}
			$ret["$_country"]["$val2"] = $categ_name;
		}
	}

	//ksort($ret);
	//var_dump('<pre>', $ret, '</pre>'); echo __FILE__ . ":" . __LINE__;die . PHP_EOL;

	//:: per country
	if ( empty($ret) ) {
		$read_status = false;
		echo '<div style="display: block;">build assets <span style="display: inline-block; margin-left: 20px; color: #' . ($read_status ? '00ff00' : 'ff0000') . '">' . ($read_status ? 'success' : 'error') . '</span></div>';
		return false;
	}

	$retd = array();
	foreach ($ret as $_country => $_categs) {
		$tmp = array();
		foreach ($_categs as $_categid => $_categname) {
			$tmp[] = implode( ',', array( $_categid, $_categname ) );
		}
		$retd["$_country"] = $tmp;
	}
	//var_dump('<pre>', $retd, '</pre>'); echo __FILE__ . ":" . __LINE__;die . PHP_EOL;

	if (!$write) return $retd;
	
	if ( !empty($country) && $country!='all' ) {
		$country1 = $__allowedCountries["$country"];
		$file_name = WZC_path_dir( 'AMAZON_WS_DIR', 'assets/nodes-' . ( $country1 ) . '.csv' );
		assets_writefile($file_name, $retd["$country"]);
	}
	else {
		foreach ( $__allowedCountries as $_country => $country1 ) {
			$file_name = WZC_path_dir( 'AMAZON_WS_DIR', 'assets/nodes-' . ( $country1 ) . '.csv' );
			assets_writefile($file_name, $retd["$_country"]);
		}
	}
		
	return $retd;
}

function assets_writefile($file_name, $content) {
	global $WooZone_Contextual;
	
	$content = implode("\n", $content);
	//var_dump('<pre>',$file_name, $content,'</pre>');  
	
	$has_wrote = $WooZone_Contextual->wp_filesystem->put_contents(
		$file_name, $content, FS_CHMOD_FILE
	);

	$has_wrote2 = false;
	if( !$has_wrote ){
		$has_wrote2 = file_put_contents( $file_name, $content );
	}
	
	$wrote_status = $has_wrote || $has_wrote2;
	
	echo '<div style="display: block;">' . $file_name .  '<span style="display: inline-block; margin-left: 20px; color: #' . ($wrote_status ? '00ff00' : 'ff0000') . '">' . ($wrote_status ? 'success' : 'error') . '</span></div>';
}

function csv_to_array($string='', $row_delimiter=PHP_EOL, $delimiter = "," , $enclosure = '"' , $escape = "\\" ) {
    $rows = array_filter(explode($row_delimiter, $string));
    $header = NULL;
    $data = array();

    foreach($rows as $row) {
        $row = str_getcsv ($row, $delimiter, $enclosure , $escape);

        if(!$header)
            $header = $row;
        else
            $data[] = array_combine($header, $row);
    }
    return $data;
}

function my_fgetcsv( $filename ) {
	$ret = array();
	ini_set('auto_detect_line_endings',TRUE);
	$row = 1;
	if ( ($handle = fopen($filename, "r")) !== FALSE ) {
	    while (($data = fgetcsv($handle, 1000, ",")) !== FALSE) {
	        $num = count($data);
	        //echo "<p> $num fields in line $row: <br /></p>\n";
	        $row++;
	        //for ($c=0; $c < $num; $c++) {
	        //    //echo $data[$c] . "<br />\n";
	        //}
	        $ret[] = $data;
	    }
	    fclose($handle);
	}
	ini_set('auto_detect_line_endings',FALSE);
	return $ret;
}


// the request
$asin = isset($_REQUEST['asin']) ? htmlentities($_REQUEST['asin']) : '';
$req = array(
	'write'				=> isset($_REQUEST['write']) ? (bool) $_REQUEST['write'] : false,
	'country'			=> isset($_REQUEST['country']) ? (string) $_REQUEST['country'] : 'all',
);
extract($req);
generateAssetsFiles( $write, $country );
die('debug...');
