/*
Author     :  AA-Team - http://themeforest.net/user/AA-Team
*/
// Initialization and events code for the app
WZC_admin = (function ($) {
    "use strict";

    // public
    var debug_level = 0,
        maincontainer = null,
        $action_status = null,
        notices_main = null,
        notices_opt = {};
    
	// init function, autoload
	(function init() {
		// load the triggers
		$(document).ready(function(){
			maincontainer = $(".WZC_iw");
			$action_status = maincontainer.find(".WZC-action-status.WZC-message");

            notices_main = $("#wzc-admin-mainnotices");
            //notices_opt = notices_main.find('.options').html();
            //notices_opt = JSON && JSON.parse(notices_opt) || $.parseJSON(notices_opt);
  
            //if (!misc.is_chrome()) {
                detect_adblock_call();
            //}

			triggers();
			fix_content_width();
		});
		
        $(window).on("load", function() {
            //if (misc.is_chrome()) {
            //    detect_adblock_call();
            //}
        });
	})();
	
	function update( data )
	{
		maincontainer.find(".WZC_iw-loader").show();
		
		maincontainer.find(".WZC_iw-loader").find('span').html('');
		$.ajax({
			url: ajaxurl,
			data: $.extend(
				{
					_ajax_custom_list_nonce: $('#_ajax_custom_list_nonce').val(),
					action: $("#ajaxid").val()
				},
				data
			),
			// Handle the successful result
			success: function( response ) {

				// WP_List_Table::ajax_response() returns json
				var response = $.parseJSON( response );

				// add the requested rows
				if ( response.rows.length )
					maincontainer.find('#the-list').html( response.rows );
					
				// update column headers for sorting
				if ( response.column_headers.length )
					maincontainer.find('thead tr, tfoot tr').html( response.column_headers );
					
				// update pagination for navigation
				if ( response.pagination.bottom.length )
					maincontainer.find('.tablenav.top .tablenav-pages').html( $(response.pagination.top).html() );
					
				if ( response.pagination.top.length )
					maincontainer.find('.tablenav.bottom .tablenav-pages').html( $(response.pagination.bottom).html() );

				// init back our event handlers
				triggers();

                multiselect_left2right();
				
				// hide the loader
				maincontainer.find(".WZC_iw-loader").fadeOut(250);
			}
		});
	}
	
	function __query( query, variable )
	{
		var vars = query.split("&");
		for ( var i = 0; i <vars.length; i++ ) {
			var pair = vars[ i ].split("=");
			if ( pair[0] == variable )
				return pair[1];
		}
		return false;
	}
	
	function fix_content_width()
	{
		maincontainer.css({
			'width': ( $("#wpbody").width() + 20 ),
			'height': ( $("#wpwrap").height() - 40 )
		});
	}
	
	function launch_amazon_search( that, search_by )
	{
		maincontainer.find(".WZC_iw-loader").show();
		
		var form = that.parents("form").eq(0),
			paged = that.data('paged');
		
		if( parseInt(paged) == 0 ){
			paged = 1;
		}
		
		$.ajax({
			url: ajaxurl,
			dataType: "json",
			method: 'post',
			data: {
				action: 'WZC_launch_amz_search',
				search_by: search_by,
				keyword: form.find('input[name="keyword"]').val(),
				node: form.find('select[name="node"]').val(),
				asin: form.find('input[name="product[ASIN]"]').val(),
				paged: paged
			},
			// Handle the successful result
			success: function( response ) {
				
				if( response.status == 'valid' ) {

    				if( search_by != "asin" ){
    					$("#WZC-dropdown-amazon-selector").html( response.html ).show();
    				}

    				else if ( search_by == "asin" ){
    					$(".WZC-product-details").each(function(){
    						var form = $(this);
    						
    						form.find('input[name="product[Title]"]').val( response.product.Title );
    						form.find('input[name="product[Brand]"]').val( response.product.Brand );
    						form.find('input[name="product[DetailPageURL]"]').val( response.product.DetailPageURL );
    						form.find('input[name="product[SmallImage]"]').val( response.product.SmallImage );
    						form.find('input[name="product[Binding]"]').val( response.product.Binding );
    						form.find('input[name="product[ListPrice]"]').val( response.product.ListPrice );
    						form.find('input[name="product[OfferSummary]"]').val( response.product.OfferSummary );
    					});
    				}
				} else {
				    $action_status.html( response.html )
				        .removeClass('WZC-success').addClass('WZC-error')
				        .show();
				}
				
				// hide the loader
				maincontainer.find(".WZC_iw-loader").fadeOut(250);
			}
		});
	}
	
	function add_product( that )
	{
		var product_details = $(".WZC-product-db-details"),
			row = that.parents('li').eq(0),
			container = row.parents("#WZC-dropdown-amazon-selector").eq(0),
			product = $.parseJSON( row.find("textarea").text() );
			
		container.fadeOut(250);
		
		product_details.find("[name='product[ASIN]']").val( product.ASIN );
		product_details.find("[name='product[Title]']").val( product.Title );
		product_details.find("[name='product[Brand]']").val( product.Brand );
		product_details.find("[name='product[DetailPageURL]']").val( product.DetailPageURL );
		product_details.find("[name='product[SmallImage]']").val( product.SmallImage );
		product_details.find("[name='product[Binding]']").val( product.Binding );
		product_details.find("[name='product[ListPrice]']").val( product.ListPrice );
		product_details.find("[name='product[OfferSummary]']").val( product.OfferSummary );
		product_details.find("[name='product[EditorialReviews]']").val( product.EditorialReviews );
	}
	
    function detect_adblock( callback_has_adblock, callback_no_adblock ) {
        // create a iframe. Append the iframe to the body. And then after 100ms check if their offsetHeight, display or visibility is set such a way that user cannot see them.
        // In the URL use the words specific to advertising so that Adblock can do string matching.
        var iframe = document.createElement("iframe");
        iframe.height = "1px";
        iframe.width = "1px";
        iframe.id = "ads-text-iframe";
        
        //iframe.style = "position: absolute; left: -1000px;";
        iframe.style.position = "absolute";
        iframe.style.left = "-1000px";
        iframe.src = "http://domain.com/ads.html";
        //http://domain.com/ads.html
        //http://pagead2.googlesyndication.com/pagead/show_ads.js
        //https://www.the-ad-server.com/ad-script.js
        
        //iframe.onerror = function() {};
        //iframe.src = notices_opt.fake_ads_path;
            
        document.body.appendChild(iframe);
        
        var contor = 0,
            timer = null;
        function _detect() {
            var iframe = document.getElementById("ads-text-iframe");
            
            contor++;

            // iframe.innerHTML.replace(/\s/g, "").length == 0
            var is_adblock = 
                !iframe
                || iframe.style.display == "none" || iframe.style.display == "hidden"
                || iframe.style.visibility == "hidden"
                || iframe.offsetHeight == 0 || iframe.clientHeight === 0;
            //console.log( contor, is_adblock ); 
            if ( is_adblock || contor >= 15 ) {

                iframe.remove();

                if ( is_adblock ) {
                    if ( $.isFunction(callback_has_adblock) ) {
                        callback_has_adblock();
                        
                        clearTimeout( timer );
                        timer = null;
                    }
                } else {
                    if ( $.isFunction(callback_no_adblock) ) {
                        callback_no_adblock();
                    }
                }
            } else {
                timer = setTimeout( _detect, 100 );
            }
        };
        timer = setTimeout( _detect, 100 ); // misc.is_chrome() ? 1000 : 100
    }
    
    function detect_adblock_call() {
        // adblock plus detection & notice!
        detect_adblock(function() {
            notices_main.find('.squeezer .adblock').show();
            notices_main.show();
        });
    }


    /* BEGIN aa-framework */
    function makeTabs()
    {
        // tabs
        $('ul.tabsHeader').each(function() {
            var child_tab = '', child_tab_s = '';

            // For each set of tabs, we want to keep track of
            // which tab is active and it's associated content
            var $active, $content, $links = $(this).find('a');
            var $content_sub;

            // If the location.hash matches one of the links, use that as the active tab.
            // If no match is found, use the first link as the initial active tab.
            var __tabsWrapper = $(this), __currentTab = $(this).find('li.tabsCurrent').attr('title');
            $active = $( $links.filter('[title="'+__currentTab+'"]')[0] || $links[0] );
            $active.addClass('active');

            // subtabs per tab!
            var __child_tab = makeTabs_subtabs( $active );
            child_tab = __child_tab.child_tab;
            if ( child_tab != '' ) child_tab_s = '.'+child_tab;
 
            $content = $( '.'+($active.attr('title')) );
            if ( child_tab != '' ) {
                $content_sub = $( '.'+($active.attr('title')) + child_tab_s );
            }

            // Hide the remaining content
            $links.not($active).each(function () {
                $( '.'+($(this).attr('title')) ).hide();
            });
            if ( child_tab != '' )
                $( '.'+($active.attr('title')) ).not( 'ul.subtabsHeader,'+child_tab_s ).hide();

            // Bind the click event handler
            $(this).on('click', 'a', function(e){
                // Make the old tab inactive.
                $active.removeClass('active');
                
                // subtabs per tab!
                var __child_tab = makeTabs_subtabs( $active );
                child_tab = __child_tab.child_tab;
                if ( child_tab != '' ) child_tab_s = '.'+child_tab;

                $content.hide();
                if ( child_tab != '' ) $content_sub.hide();

                // Update the variables with the new link and content
                __currentTab = $(this).attr('title');
                __tabsWrapper.find('li.tabsCurrent').attr('title', __currentTab);
                $active = $(this);
                
                // subtabs per tab!
                var __child_tab = makeTabs_subtabs( $active );
                child_tab = __child_tab.child_tab;
                if ( child_tab != '' ) child_tab_s = '.'+child_tab;

                $content = $( '.'+($(this).attr('title')) );
                if ( child_tab != '' )
                    $content_sub = $( '.'+($(this).attr('title')) + child_tab_s );

                // Make the tab active.
                $active.addClass('active');
                if ( child_tab != '' ) $content_sub.show();
                else $content.show();

                // Prevent the anchor's default click action
                e.preventDefault();
            });
        });
        
        // subtabs
        $('ul.subtabsHeader').each(function() {
            var parent_tab = $(this).data('parent'), parent_tab_s = '.'+parent_tab;

            // For each set of tabs, we want to keep track of
            // which tab is active and it's associated content
            var $active_sub, $content_sub, $links_sub = $(this).find('a');
 
            // If the location.hash matches one of the links, use that as the active tab.
            // If no match is found, use the first link as the initial active tab.
            var __tabsWrapper = $(this), __currentTab = $(this).find('li.tabsCurrent').attr('title');
            $active_sub = $( $links_sub.filter('[title="'+__currentTab+'"]')[0] || $links_sub[0] );
            $active_sub.addClass('active');
            $content_sub = $(parent_tab_s + '.'+($active_sub.attr('title')));
            
            // Bind the click event handler
            $(this).on('click', 'a', function(e){
                // Make the old tab inactive.
                $active_sub.removeClass('active');
                $content_sub.hide();

                // Update the variables with the new link and content
                __currentTab = $(this).attr('title');
                __tabsWrapper.find('li.tabsCurrent').attr('title', __currentTab);
                $active_sub = $(this);
                $content_sub = $( parent_tab_s + '.'+($(this).attr('title')) );

                // Make the tab active.
                $active_sub.addClass('active');
                $content_sub.show();

                // Prevent the anchor's default click action
                e.preventDefault();
            });
        });
    }
    
    function makeTabs_subtabs( active_tab ) {
 
        var ret = { 'child_tab': "" };

        var $subtabsWrapper = $('ul.subtabsHeader').filter(function(i) {
            return ( $(this).data('parent') == active_tab.attr('title') );
        });

            $('ul.subtabsHeader').hide();
        if ( $subtabsWrapper.length > 0 ) {

            $subtabsWrapper.show();

            // For each set of tabs, we want to keep track of
            // which tab is active and it's associated content
            var $active, $links = $subtabsWrapper.find('a');

            // If the location.hash matches one of the links, use that as the active tab.
            // If no match is found, use the first link as the initial active tab.
            var __tabsWrapper = $subtabsWrapper, __currentTab = $subtabsWrapper.find('li.tabsCurrent').attr('title');
            $active = $( $links.filter('[title="'+__currentTab+'"]')[0] || $links[0] );
            $active.addClass('active');

            ret.child_tab = $active.attr('title');
        }
        return ret;
    }
    
    function multiselect_left2right( autselect ) {
        var $allListBtn = $('.multisel_l2r_btn');
        var autselect = autselect || false;
 
        if ( $allListBtn.length > 0 ) {
            $allListBtn.each(function(i, el) {
 
                var $this = $(el), $multisel_available = $this.prevAll('.psp-multiselect-available').find('select.multisel_l2r_available'), $multisel_selected = $this.prevAll('.psp-multiselect-selected').find('select.multisel_l2r_selected');
 
                if ( autselect ) {
                    $multisel_selected.find('option').each(function() {
                        $(this).prop('selected', true);
                    });
                    $multisel_available.find('option').each(function() {
                        $(this).prop('selected', false);
                    });
                } else {

                $this.on('click', '.moveright', function(e) {
                    e.preventDefault();
                    $multisel_available.find('option:selected').appendTo($multisel_selected);
                });
                $this.on('click', '.moverightall', function(e) {
                    e.preventDefault();
                    $multisel_available.find('option').appendTo($multisel_selected);
                });
                $this.on('click', '.moveleft', function(e) {
                    e.preventDefault();
                    $multisel_selected.find('option:selected').appendTo($multisel_available);
                });
                $this.on('click', '.moveleftall', function(e) {
                    e.preventDefault();
                    $multisel_selected.find('option').appendTo($multisel_available);
                });
                
                }
            });
        }
    }
    
    function saveOptions($btn)
    {
        var theForm         = $btn.parents('form').eq(0),
            value           = $btn.val(),
            statusBoxHtml   = theForm.find('div#WZC-status-box');

        // replace the save button value with loading message
        $btn.val('saving setings ...').removeClass('green').addClass('gray');

        multiselect_left2right(true);
        
        theForm.submit();
        
        // replace the save button value with default message
        $btn.val( value ).removeClass('gray').addClass('green');
    }
    /* END aa-framework */


	function triggers()
	{
        makeTabs();

		$('body').on('click', 'button.WZC-add-btn', function(e){
			e.preventDefault();
			add_product( $(this) );
		});
		
		$('body').on('click', '.WZC-items-pagination a.WZC-pagination-close', function(e){
			e.preventDefault();
			
			$('#WZC-dropdown-amazon-selector').html('').hide();
		});
		
		$('body').on('click', '#WZC-search-on-amazon, .WZC-items-pagination button, .WZC-find-product-by-id', function(e){
			e.preventDefault();
			
			var that = $(this),
				type = 'keyword';
			
			if( that.hasClass("WZC-find-product-by-id") ){
				type = 'asin';
			}
			 
			launch_amazon_search( that, type );
		});

		// Pagination links, sortable link
		maincontainer.find('.tablenav-pages a, .manage-column.sortable a, .manage-column.sorted a').on('click', function(e) {
			e.preventDefault();
			
			// use the URL to extract our needed variables
			var query = this.search.substring( 1 );
			
			var data = {
				paged: __query( query, 'paged' ) || '1',
				order: __query( query, 'order' ) || 'desc',
				orderby: __query( query, 'orderby' ) || 'id'
			};
  
			update( data );
		});

		// page number input
		maincontainer.find('input[name=paged]').on('keyup', function(e) {

			// If user hit enter, we don't want to submit the form
			if ( 13 == e.which )
				e.preventDefault();

			// This time we fetch the variables in inputs
			var data = {
				paged: parseInt( maincontainer.find('input[name=paged]').val() ) || '1',
				order: maincontainer.find('input[name=order]').val() || 'desc',
				orderby: maincontainer.find('input[name=orderby]').val() || 'id',
				filter_by: maincontainer.find('input[name=filter_by]').val() || 'post',
			};
 
			update( data );
		});
		
		maincontainer.find('select[name=filter_by]').on('change', function(e) {
			var that = $(this),
				val = that.val();
			
			maincontainer.find('select[name=filter_by]').val( val ); 
		});
		
		// bulk actions - Apply
        maincontainer.find('input#doaction').on('click', function(e) {
            e.preventDefault();
            
            var that = $(this),
                form = that.parents('form').eq(0),
                _action = form.find('select#bulk-action-selector-top').val();
 
            // '_ajax_custom_list_nonce', 'ajaxid', 'order', 'orderby', '_wpnonce', '_wp_http_referer'
            var field_reset = ['_ajax_custom_list_nonce', 'ajaxid', 'order', 'orderby', '_wp_http_referer'];
            for (var i in field_reset) {
                $( 'input[name="'+field_reset[i]+'"]' ).remove();
            }
            if ( 'delete' == _action ) {
                $( 'input[name="paged"]' ).val(1);
            }
  
            form.submit();
        });
		
		$('.WZC-wp-color-picker').wpColorPicker();
		
        $('body').on('click', '.WZC-saveOptions', function(e) {
            e.preventDefault();
            saveOptions( $(this) );
        });
        
        multiselect_left2right();
		
	}
	
    var misc = {
        is_chrome: function() {
            return window.chrome;
            //return navigator.userAgent.toLowerCase().indexOf('chrome') > -1;
        }
    }

	// external usage
	return {
		'triggers'                  : triggers,
        'makeTabs'                  : makeTabs,
        'multiselect_left2right'    : multiselect_left2right
	}
})(jQuery);
