<?php
if ( !class_exists('WZC_keywords2content') ) {
	class WZC_keywords2content {
	
	    public function __construct() {}
	    
	    private function _ignore_common_words( $word='' ) 
	    {
	        $commonWords = array('a','able','about','above','abroad','according','accordingly','across','actually','adj','after','afterwards','again','against','ago','ahead','ain\'t','all','allow','allows','almost','alone','along','alongside','already','also','although','always','am','amid','amidst','among','amongst','an','and','another','any','anybody','anyhow','anyone','anything','anyway','anyways','anywhere','apart','appear','appreciate','appropriate','are','aren\'t','around','as','a\'s','aside','ask','asking','associated','at','available','away','awfully','b','back','backward','backwards','be','became','because','become','becomes','becoming','been','before','beforehand','begin','behind','being','believe','below','beside','besides','best','better','between','beyond','both','brief','but','by','c','came','can','cannot','cant','can\'t','caption','cause','causes','certain','certainly','changes','clearly','c\'mon','co','co.','com','come','comes','concerning','consequently','consider','considering','contain','containing','contains','corresponding','could','couldn\'t','course','c\'s','currently','d','dare','daren\'t','definitely','described','despite','did','didn\'t','different','directly','do','does','doesn\'t','doing','done','don\'t','down','downwards','during','e','each','edu','eg','eight','eighty','either','else','elsewhere','end','ending','enough','entirely','especially','et','etc','even','ever','evermore','every','everybody','everyone','everything','everywhere','ex','exactly','example','except','f','fairly','far','farther','few','fewer','fifth','first','five','followed','following','follows','for','forever','former','formerly','forth','forward','found','four','from','further','furthermore','g','get','gets','getting','given','gives','go','goes','going','gone','got','gotten','greetings','h','had','hadn\'t','half','happens','hardly','has','hasn\'t','have','haven\'t','having','he','he\'d','he\'ll','hello','help','hence','her','here','hereafter','hereby','herein','here\'s','hereupon','hers','herself','he\'s','hi','him','himself','his','hither','hopefully','how','howbeit','however','hundred','i','i\'d','ie','if','ignored','i\'ll','i\'m','immediate','in','inasmuch','inc','inc.','indeed','indicate','indicated','indicates','inner','inside','insofar','instead','into','inward','is','isn\'t','it','it\'d','it\'ll','its','it\'s','itself','i\'ve','j','just','k','keep','keeps','kept','know','known','knows','l','last','lately','later','latter','latterly','least','less','lest','let','let\'s','like','liked','likely','likewise','little','look','looking','looks','low','lower','ltd','m','made','mainly','make','makes','many','may','maybe','mayn\'t','me','mean','meantime','meanwhile','merely','might','mightn\'t','mine','minus','miss','more','moreover','most','mostly','mr','mrs','much','must','mustn\'t','my','myself','n','name','namely','nd','near','nearly','necessary','need','needn\'t','needs','neither','never','neverf','neverless','nevertheless','new','next','nine','ninety','no','nobody','non','none','nonetheless','noone','no-one','nor','normally','not','nothing','notwithstanding','novel','now','nowhere','o','obviously','of','off','often','oh','ok','okay','old','on','once','one','ones','one\'s','only','onto','opposite','or','other','others','otherwise','ought','oughtn\'t','our','ours','ourselves','out','outside','over','overall','own','p','particular','particularly','past','per','perhaps','placed','please','plus','possible','presumably','probably','provided','provides','q','que','quite','qv','r','rather','rd','re','really','reasonably','recent','recently','regarding','regardless','regards','relatively','respectively','right','round','s','said','same','saw','say','saying','says','second','secondly','see','seeing','seem','seemed','seeming','seems','seen','self','selves','sensible','sent','serious','seriously','seven','several','shall','shan\'t','she','she\'d','she\'ll','she\'s','should','shouldn\'t','since','six','so','some','somebody','someday','somehow','someone','something','sometime','sometimes','somewhat','somewhere','soon','sorry','specified','specify','specifying','still','sub','such','sup','sure','t','take','taken','taking','tell','tends','th','than','thank','thanks','thanx','that','that\'ll','thats','that\'s','that\'ve','the','their','theirs','them','themselves','then','thence','there','thereafter','thereby','there\'d','therefore','therein','there\'ll','there\'re','theres','there\'s','thereupon','there\'ve','these','they','they\'d','they\'ll','they\'re','they\'ve','thing','things','think','third','thirty','this','thorough','thoroughly','those','though','three','through','throughout','thru','thus','till','to','together','too','took','toward','towards','tried','tries','truly','try','trying','t\'s','twice','two','u','un','under','underneath','undoing','unfortunately','unless','unlike','unlikely','until','unto','up','upon','upwards','us','use','used','useful','uses','using','usually','v','value','various','versus','very','via','viz','vs','w','want','wants','was','wasn\'t','way','we','we\'d','welcome','well','we\'ll','went','were','we\'re','weren\'t','we\'ve','what','whatever','what\'ll','what\'s','what\'ve','when','whence','whenever','where','whereafter','whereas','whereby','wherein','where\'s','whereupon','wherever','whether','which','whichever','while','whilst','whither','who','who\'d','whoever','whole','who\'ll','whom','whomever','who\'s','whose','why','will','willing','wish','with','within','without','wonder','won\'t','would','wouldn\'t','x','y','yes','yet','you','you\'d','you\'ll','your','you\'re','yours','yourself','yourselves','you\'ve','z','zero');
	 
	        $word = strtolower($word);
	        if( in_array($word, $commonWords) ){
	            return true;
	        }
	        return false;
	    }
	
	    private function _validate_phrase( $phrase ) 
	    {
	        $phrase = preg_replace('/ss+/i', '', $phrase);
	        $phrase = trim($phrase);
	        //$phrase = preg_quote( $phrase, '/' );
	
	        /*
	        $regexp = '/^[a-zA-Z0-9_' . ( preg_quote('-()/.', '/') ) . ']*$/iu';
	        $mstat = preg_match($regexp, $phrase, $m);
	        if ( !$mstat ) {
	            return false;
	        }
			*/
	        if ( strlen($phrase) <= 1 ) {
	            return false;
	        }
	        if ( $this->_ignore_common_words( $phrase ) ) {
	            return false;
	        }
	        return true;
	    }
	    
	    private function _init_words( $words, $cwords ) 
	    {
	        $_words = array();
	        $_words = array_intersect( $cwords, $words );
	        $_words = array_unique( $_words );
	        return $_words;
	    }
	
	    private function _clean_content( $content ) 
	    {
	    	//return $content;
	        $content = strip_tags($content, '<p><br><br/>');
	        $content = preg_replace('/\s\s+/iu', ' ', $content); // replace whitespace characters with a single space
	        //$content = preg_replace('/,|\./iu', '', $content); // replace special chars
	        $content = preg_replace('/(\r\n|\r|\n)+/im', ' ', $content); // normalize newlines
	        return $content;
	    }
        
        private function _clean_words($e) {
            $e = trim($e, '.,/>');
            return $e;
        }
	
	    public function make( $keyword, $content, $min_words=1 ) 
	    {
	
	        // parse keywords
	        {
	            $keyword = preg_replace('/\s\s+/iu', '', $keyword);
	            $keyword = trim($keyword);
	            $words = explode( ' ', $keyword );
	            $words = $this->_init_words( $words, explode(' ', $content) );
	
	            // build words hashes & replace them in the content
	            $_content = $content;
				//var_dump('<pre>',$_content,'</pre>'); die;  
 	            $hashes = array();
	            foreach ( $words as $word ) {
	            	
					if( $this->_validate_phrase($word) === false ){
						continue;
					}
					
	                $word = strtolower($word);
	                $hash = '##'.md5( $word ).'##';
	
	                $hashes["$hash"] = $word;
	                $_content = preg_replace('/\b'.preg_quote($word, '/').'\b/iu', $hash, $_content);
	            } // end foreach words
	            

	            // split content into words
	            $cwords = (array) explode(' ', $_content);
                //$cwords = array_map( array($this, '_clean_words'), $cwords );
                //var_dump('<pre>', $cwords, '</pre>'); die('debug...'); 
	            
	            // build combinations found in content
	            $cc = 0; $prev_found = false;
	            $found = array();
	            foreach ( $cwords as $cword ) {
	                if ( isset($hashes["$cword"]) ) {
	                    if ( $prev_found ) {
	                        $found[$cc][] = $hashes["$cword"];
	                    } else {
	                        $found[++$cc][] = $hashes["$cword"];
	                    }
	                    $prev_found = true;
	                } else {
	                    $prev_found = false;
	                }
	            }
	            //var_dump('<pre>',$found,'</pre>'); 
	            
	            // keep only unique combinations
	            $_found = array();
	            foreach ( $found as $combination ) {
	                $_combination = implode(' ', $combination);
	                $hash = '##'.md5( $_combination ).'##';
	                $depth = count($combination);
	                
	                if ( !isset($_found["$hash"]) ) {
	                    $_found["$hash"] = array( 
	                        'depth'     => $depth,
	                        'words'     => $_combination
	                    );
	                }
	            }
	            //var_dump('<pre>',$_found,'</pre>'); 
	            
	            // keep combinations based on allowed min words
	            foreach ( $_found as $key => $combination ) {
	                if ( $combination['depth'] < $min_words ) {
	                    unset($_found["$key"]);
	                }
	            }
	            //var_dump('<pre>',$_found,'</pre>');
	            
	            // sort combinations first based on depth (DESC) and second on words (ASC) 
                uasort($_found, array($this, 'compare_founds_depth__'));
                //var_dump('<pre>',$_found,'</pre>');
	
	        } // end parse keywords
	        return $_found;
	    }

        public function compare_founds_depth__($a, $b) {
            $retval = (int) ( $a['depth'] < $b['depth'] ? 1 : ( $a['depth'] == $b['depth'] ? 0 : -1 ) );
            if ( !$retval ) {
                $retval = strnatcmp($a['words'], $b['words']);
            }
            return $retval;
        }
	
	    public function make_all( $products=array(), $content='', $min_words=1 ) 
	    {
	        // clean page content
	        if ( empty($content) ) {
	            var_dump('<pre>', 'empty content', '</pre>'); die('debug...');
	            return array();
	        }
	        $content = $this->_clean_content( $content );
	 
	        // parse keywords
	        $found = array();
	        foreach ( $products as $product ) {
	        	
				// if( $product['Title'] != "" ) continue; // debug 
				
	            $hash = '##'.md5( $product['Title'] ).'##'; 
	            $found["$hash"] = array(
	                'product' 	=> $product,
	                'results'   => $this->make( $product['Title'], $content, $min_words )
	            );
	        } // end foreach keywords
	        
	        return $found;
	    }

	}
}